Index: code/branches/spacerace/data/levels/spaceRace.oxw
===================================================================
--- code/branches/spacerace/data/levels/spaceRace.oxw	(revision 8616)
+++ code/branches/spacerace/data/levels/spaceRace.oxw	(revision 8617)
@@ -61,5 +61,5 @@
     <RaceCheckPoint name="checkpoint1" position="0,-2000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="false">
         <attached>
-        <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+        <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
         </attached>
         <collisionShapes>
@@ -73,5 +73,5 @@
     <RaceCheckPoint name="checkpoint2" position="0,-900,2300" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
         <events>
@@ -107,5 +107,5 @@
     <RaceCheckPoint name="checkpoint3" position="0,700,2700" stayActive="true" direction="0,0,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
         <events>
@@ -141,5 +141,5 @@
     <RaceCheckPoint name="checkpoint4" position="0,2100,2300" stayActive="true" direction="0,1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false">
    <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger3" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -176,5 +176,5 @@
     <RaceCheckPoint name="checkpoint5" position="0,2200,500" stayActive="true" direction="0,1,0" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger4" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -211,5 +211,5 @@
     <RaceCheckPoint name="checkpoint6" position="0,1500,-800" stayActive="true" direction="0,1,-1" collisionType="static" scale="1" distance="40" checkpointindex="5" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger5" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -246,5 +246,5 @@
     <RaceCheckPoint name="checkpoint7" position="0,200,-1900" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="6" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger6" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -281,5 +281,5 @@
     <RaceCheckPoint name="checkpoint8" position="0,-700,-1400" stayActive="true" direction="0,-1,-1" collisionType="static" scale="1" distance="40" checkpointindex="7" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger7" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -316,5 +316,5 @@
     <RaceCheckPoint name="checkpoint9" position="0,-1300,-800" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="8" islast="false">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
       <DistanceTrigger name="trigger8" position="0,0,0" distance=40 stayActive="true" />
       <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
@@ -342,5 +342,5 @@
     <RaceCheckPoint name="checkpoint10" position="0,-2100,0" collisionType="static" scale="1" distance="40" checkpointindex="9" islast="true" timelimit="150">
     <attached>
-      <Model mass="50" scale="50" mesh="checkPoint.mesh" />
+      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
     </attached>
      <collisionShapes>
Index: code/branches/spacerace/src/modules/gametypes/RaceCheckPoint.cc
===================================================================
--- code/branches/spacerace/src/modules/gametypes/RaceCheckPoint.cc	(revision 8616)
+++ code/branches/spacerace/src/modules/gametypes/RaceCheckPoint.cc	(revision 8617)
@@ -112,6 +112,6 @@
 		  if (gametype)
 		  {
-		     const std::string& message =  "You have " + multi_cast<std::string>(this->bTimeLimit_)
-						   + " seconds to reach the check point " + multi_cast<std::string>(this->bCheckpointIndex_+1) + "\n";
+		     const std::string& message =  "\nYou have " + multi_cast<std::string>(this->bTimeLimit_)
+						   + " seconds to reach the check point " + multi_cast<std::string>(this->bCheckpointIndex_+1) + "\n\n";
 		     COUT(0) << message;
 		     const_cast<GametypeInfo*>(gametype->getGametypeInfo())->sendAnnounceMessage(message);