Index: code/branches/spacerace/data/levels/spaceRace.oxw
===================================================================
--- code/branches/spacerace/data/levels/spaceRace.oxw	(revision 8617)
+++ code/branches/spacerace/data/levels/spaceRace.oxw	(revision 8630)
@@ -61,293 +61,293 @@
     <RaceCheckPoint name="checkpoint1" position="0,-2000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="false">
         <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </RaceCheckPoint>
+
+    <RaceCheckPoint name="checkpoint2" position="0,-900,2300" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false">
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <Trigger mode="xor" invert="true" >
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint2" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert="true">
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint3" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </RaceCheckPoint>
+
+    <RaceCheckPoint name="checkpoint3" position="0,700,2700" stayActive="true" direction="0,0,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false">
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <Trigger mode="xor" invert="true" >
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint3" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert="true">
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint4" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </RaceCheckPoint>
+
+    <RaceCheckPoint name="checkpoint4" position="0,2100,2300" stayActive="true" direction="0,1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false">
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <DistanceTrigger name="trigger3" position="0,0,0" distance=40 stayActive="true" />
+            <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <Trigger mode="xor" invert="true" >
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint4" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert="true">
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint5" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </RaceCheckPoint>
+
+    <RaceCheckPoint name="checkpoint5" position="0,2200,500" stayActive="true" direction="0,1,0" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false">
+        <attached>
         <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-        </attached>
-        <collisionShapes>
-        <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-        <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-        <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-        <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-        </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint2" position="0,-900,2300" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint2" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint3" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-    <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint3" position="0,700,2700" stayActive="true" direction="0,0,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <SpawnPoint position="0,0,0" lookat="0,1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint3" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint4" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint4" position="0,2100,2300" stayActive="true" direction="0,1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false">
-   <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger3" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint4" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint5" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint5" position="0,2200,500" stayActive="true" direction="0,1,0" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger4" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-         <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint5" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint6" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <DistanceTrigger name="trigger4" position="0,0,0" distance=40 stayActive="true" />
+        <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+            <events>
+            <activity>
+                <Trigger mode="xor" invert="true" >
+                    <EventTrigger>
+                        <events>
+                            <trigger>
+                                <EventListener event="checkpoint5" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                    <EventTrigger invert="true">
+                        <events>
+                            <trigger>
+                                <EventListener event="checkpoint6" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                </Trigger>
+            </activity>
+            </events>
+        </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
     <RaceCheckPoint name="checkpoint6" position="0,1500,-800" stayActive="true" direction="0,1,-1" collisionType="static" scale="1" distance="40" checkpointindex="5" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger5" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint6" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint7" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <DistanceTrigger name="trigger5" position="0,0,0" distance=40 stayActive="true" />
+            <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <Trigger mode="xor" invert="true" >
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint6" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert="true">
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint7" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
     <RaceCheckPoint name="checkpoint7" position="0,200,-1900" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="6" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger6" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint7" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint8" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <DistanceTrigger name="trigger6" position="0,0,0" distance=40 stayActive="true" />
+            <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <Trigger mode="xor" invert="true" >
+                        <EventTrigger>
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint7" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                        <EventTrigger invert="true">
+                            <events>
+                                <trigger>
+                                    <EventListener event="checkpoint8" />
+                                </trigger>
+                            </events>
+                        </EventTrigger>
+                    </Trigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
     <RaceCheckPoint name="checkpoint8" position="0,-700,-1400" stayActive="true" direction="0,-1,-1" collisionType="static" scale="1" distance="40" checkpointindex="7" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger7" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <Trigger mode="xor" invert="true" >
-                <EventTrigger>
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint8" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-                <EventTrigger invert="true">
-                    <events>
-                        <trigger>
-                            <EventListener event="checkpoint9" />
-                        </trigger>
-                    </events>
-                </EventTrigger>
-            </Trigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <attached>
+        <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+        <DistanceTrigger name="trigger7" position="0,0,0" distance=40 stayActive="true" />
+        <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+            <events>
+            <activity>
+                <Trigger mode="xor" invert="true" >
+                    <EventTrigger>
+                        <events>
+                            <trigger>
+                                <EventListener event="checkpoint8" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                    <EventTrigger invert="true">
+                        <events>
+                            <trigger>
+                                <EventListener event="checkpoint9" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                </Trigger>
+            </activity>
+            </events>
+        </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
     <RaceCheckPoint name="checkpoint9" position="0,-1300,-800" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="8" islast="false">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-      <DistanceTrigger name="trigger8" position="0,0,0" distance=40 stayActive="true" />
-      <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
-        <events>
-          <activity>
-            <EventTrigger>
-                <events>
-                    <trigger>
-                        <EventListener event="checkpoint9" />
-                    </trigger>
-                </events>
-            </EventTrigger>
-          </activity>
-        </events>
-      </SpawnPoint>
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+            <DistanceTrigger name="trigger8" position="0,0,0" distance=40 stayActive="true" />
+            <SpawnPoint position="0,0,0" lookat="0,-1000,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+                <events>
+                <activity>
+                    <EventTrigger>
+                        <events>
+                            <trigger>
+                                <EventListener event="checkpoint9" />
+                            </trigger>
+                        </events>
+                    </EventTrigger>
+                </activity>
+                </events>
+            </SpawnPoint>
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
     <RaceCheckPoint name="checkpoint10" position="0,-2100,0" collisionType="static" scale="1" distance="40" checkpointindex="9" islast="true" timelimit="150">
-    <attached>
-      <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-    </attached>
-     <collisionShapes>
-      <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-      <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-      <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-    </collisionShapes>
+        <attached>
+        <   Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
     </RaceCheckPoint>
 
@@ -355,7 +355,7 @@
     <Planet position="0,0,0" scale=300 pitch=-90 mesh="iceplanet.mesh" atmosphere="atmosphere1" rotationaxis="8,1,0" rotationrate="1" atmospheresize=224.0f imagesize=1024.0f />
     <StaticEntity position="0,0,0" collisionType=static>
-	<collisionShapes>
-	    <SphereCollisionShape radius="399" />
-	</collisionShapes>
+        <collisionShapes>
+            <SphereCollisionShape radius="399" />
+        </collisionShapes>
     </StaticEntity>
 
@@ -365,5 +365,5 @@
     for i = 0, max, 1
     do
-	y = math.sin(i/max*6)*2000
+    y = math.sin(i/max*6)*2000
     z = math.cos(i/max*6)*2500
     x = 0
@@ -385,8 +385,8 @@
       <attached>
         <Model position="0,0,0" scale="<?lua print(j * 10) ?>" mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh">
-	  <?lua if k == 5 then ?><attached><!-- ---------asteroid fog----- -->
+      <?lua if k == 5 then ?><attached><!-- ---------asteroid fog----- -->
             <ParticleEmitter position="0,0,0" source="Orxonox/Steam" />
           </attached> <?lua end ?>
-	</Model>
+        </Model>
       </attached>
       <collisionShapes>
@@ -451,7 +451,7 @@
       <controller>
          <WaypointPatrolController alertnessradius=1500 team=0 >
-              <waypoints>
-		  <Model scale=0 position="0,2000,2000" />
-	      </waypoints>
+            <waypoints>
+                <Model scale=0 position="0,2000,2000" />
+            </waypoints>
          </WaypointPatrolController>
       </controller>
@@ -463,9 +463,9 @@
       </templates>
       <controller>
-	  <WaypointPatrolController alertnessradius=1500 team=0 >
-                <waypoints>
-                    <Model scale=0 position="0,2000,-2000" />
-                </waypoints>
-          </WaypointPatrolController>
+        <WaypointPatrolController alertnessradius=1500 team=0 >
+            <waypoints>
+                <Model scale=0 position="0,2000,-2000" />
+            </waypoints>
+        </WaypointPatrolController>
       </controller>
     </SpaceShip>